Générateur TOTP (codes 2FA)

Générez des mots de passe à usage unique TOTP depuis un secret Base32 avec SHA-1/256/512, 6 à 8 chiffres et toute période. Compte à rebours, RFC 6238 vérifiée.

La clé affichée par le service lors de l’activation de la 2FA. Espaces et minuscules acceptés.

Laissez vide pour utiliser l’heure actuelle.

TOTP (RFC 6238) calcule HOTP avec le compteur T = floor(temps Unix / période). La plupart des applis utilisent SHA-1, 6 chiffres et 30 secondes. L’horloge de l’appareil doit être exacte. La clé ne quitte jamais votre navigateur, mais traitez-la comme un mot de passe.

S'exécute entièrement dans votre navigateur. Vos données ne sont jamais envoyées.

Qu'est-ce que Générateur TOTP (2FA) ?

Cet outil calcule, à partir d’une clé secrète Base32, les mêmes codes de 6 à 8 chiffres que les applications d’authentification. Il se rafraîchit en direct avec un compte à rebours, affiche aussi les codes précédent et suivant, et peut calculer le code pour n’importe quel temps Unix afin de tester des serveurs.

Comment utiliser Générateur TOTP (2FA)

  1. Collez la Clé secrète (Base32) ou cliquez sur Nouvelle clé aléatoire.
  2. Réglez Algorithme, Chiffres et Période (secondes) selon le service (en général SHA-1, 6, 30).
  3. Lisez le code actuel et les secondes restantes.
  4. Saisissez au besoin un Temps Unix (facultatif) pour calculer le code d’un instant précis.

Exemple

Entrée
Secret GEZDGNBVGY3TQOJQGEZDGNBVGY3TQOJQ, SHA-1, 8 digits, Unix time 59
Sortie
94287082

Vecteur de test de l’annexe B de la RFC 6238 (le secret est l’ASCII 12345678901234567890 en Base32).

Quand utiliser Générateur TOTP (2FA)

Utilisez-le pour tester une implémentation 2FA, retrouver des codes sur un ordinateur quand vous avez le secret, ou comprendre le fonctionnement de TOTP. Ne gardez pas les secrets de vos vrais comptes dans des onglets de navigateur ; utilisez une application d’authentification ou un gestionnaire de mots de passe.

Comment fonctionne Générateur TOTP (2FA)

TOTP (RFC 6238) calcule HOTP (RFC 4226) avec le compteur T = floor(temps Unix / période) : HMAC-SHA-1/256/512 du compteur de 8 octets big-endian avec la clé secrète décodée du Base32, puis troncature dynamique (décalage = dernier quartet) et modulo 10^chiffres. HMAC est calculé avec la Web Crypto API. Tous les vecteurs de test de l’annexe B de la RFC 6238 sont reproduits exactement.

Cas d'utilisation courants

  • Tester la connexion TOTP d’une application web en développement
  • Vérifier la dérive d’horloge d’un serveur en comparant les codes
  • Reproduire les vecteurs de test de la RFC 6238
  • Générer des codes pour un compte de test dans une documentation CI

Note de Sécurité

Un secret TOTP est aussi sensible qu’un mot de passe : quiconque le possède peut générer vos codes.

Questions Fréquentes

Pourquoi mes codes ne correspondent-ils pas à l’application ?

Vérifiez que l’algorithme, les chiffres et la période correspondent, et que l’horloge de votre ordinateur est exacte ; 30 secondes d’écart changent le code.

Mon secret est-il envoyé quelque part ?

Non. HMAC est calculé dans votre navigateur avec Web Crypto.

Quel alphabet Base32 est utilisé ?

Celui de la RFC 4648 : A–Z et 2–7. Espaces, tirets, minuscules et remplissage = sont acceptés et ignorés.

Explorer d'autres catégories